diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 0d21ec3bf..3d5a44b5a 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1,38 +1,11 @@
 package net.minecraft.client.render;
 
-import java.nio.IntBuffer;
-import java.util.ArrayList;
-import java.util.Arrays;
-import java.util.List;
-import java.util.Random;
-
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import org.lwjgl.opengl.ARBOcclusionQuery;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL15;
-
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityArrowGoldenFX;
-import net.minecraft.client.entity.fx.EntityBubbleFX;
-import net.minecraft.client.entity.fx.EntityDiggingFX;
-import net.minecraft.client.entity.fx.EntityExplodeFX;
-import net.minecraft.client.entity.fx.EntityFireflyFX;
-import net.minecraft.client.entity.fx.EntityFlameFX;
-import net.minecraft.client.entity.fx.EntityFlameFX.Type;
-import net.minecraft.client.entity.fx.EntityFootStepFX;
-import net.minecraft.client.entity.fx.EntityHeartFX;
-import net.minecraft.client.entity.fx.EntityItemFX;
-import net.minecraft.client.entity.fx.EntityLavaFX;
-import net.minecraft.client.entity.fx.EntityLeafFX;
-import net.minecraft.client.entity.fx.EntityNoteFX;
-import net.minecraft.client.entity.fx.EntityPortalFX;
-import net.minecraft.client.entity.fx.EntityReddustFX;
-import net.minecraft.client.entity.fx.EntitySlimeChunkFX;
-import net.minecraft.client.entity.fx.EntitySmokeFX;
-import net.minecraft.client.entity.fx.EntitySnowShovelFX;
-import net.minecraft.client.entity.fx.EntitySplashFX;
+import net.minecraft.client.entity.fx.EntityFX;
+import net.minecraft.client.entity.fx.ParticleDispatcher;
 import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.option.enums.RenderDistance;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
@@ -40,15 +13,14 @@ import net.minecraft.client.render.block.model.BlockModelLeaves;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
-import net.minecraft.client.render.tessalator.Tessellator;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.core.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
@@ -65,6 +37,9 @@ import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
+import org.lwjgl.opengl.ARBOcclusionQuery;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL15;
 
 import java.nio.IntBuffer;
 import java.util.ArrayList;
@@ -72,10 +47,6 @@ import java.util.Arrays;
 import java.util.List;
 import java.util.Random;
 
-import org.lwjgl.opengl.ARBOcclusionQuery;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL15;
-
 
 import static org.lwjgl.opengl.GL11.GL_FOG;
 import static org.lwjgl.opengl.GL11.GL_LINES;
@@ -1604,11 +1575,15 @@ public class RenderGlobal
     }
 
     @Override
-	public void playStreamingMusic(String soundPath, int x, int y, int z)
+	public void playStreamingMusic(String soundPath, String author, int x, int y, int z)
     {
         if(soundPath != null)
         {
-            mc.ingameGUI.setRecordPlayingMessage("C418 - " + soundPath);
+            if (author != null && !author.isEmpty()){
+                mc.ingameGUI.setRecordPlayingMessage(author + " - " + soundPath);
+            } else {
+                mc.ingameGUI.setRecordPlayingMessage(soundPath);
+            }
         }
         mc.sndManager.playStreaming(soundPath, x, y, z, 1.0F, 1.0F);
     }
@@ -1649,111 +1624,9 @@ public class RenderGlobal
         {
             return;
         }
-        if(particleId.equals("bubble"))
-        {
-            mc.effectRenderer.addEffect(new EntityBubbleFX(worldObj, x, y, z, motionX, motionY, motionZ, true));
-        }
-        else if(particleId.equals("smoke"))
-        {
-            mc.effectRenderer.addEffect(new EntitySmokeFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("note"))
-        {
-            mc.effectRenderer.addEffect(new EntityNoteFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("portal"))
-        {
-            mc.effectRenderer.addEffect(new EntityPortalFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("explode"))
-        {
-            mc.effectRenderer.addEffect(new EntityExplodeFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("flame"))
-        {
-            mc.effectRenderer.addEffect(new EntityFlameFX(worldObj, x, y, z, motionX, motionY, motionZ, Type.ORANGE));
-        }
-        else if(particleId.equals("blueflame"))
-        {
-            mc.effectRenderer.addEffect(new EntityFlameFX(worldObj, x, y, z, motionX, motionY, motionZ, Type.BLUE));
-        }
-        else if(particleId.equals("soulflame"))
-        {
-            mc.effectRenderer.addEffect(new EntityFlameFX(worldObj, x, y, z, motionX, motionY, motionZ, Type.SOUL));
-        }
-        else if(particleId.equals("lava"))
-        {
-            mc.effectRenderer.addEffect(new EntityLavaFX(worldObj, x, y, z));
-        }
-        else if(particleId.equals("footstep"))
-        {
-            mc.effectRenderer.addEffect(new EntityFootStepFX(renderEngine, worldObj, x, y, z));
-        }
-        else if(particleId.equals("splash"))
-        {
-            mc.effectRenderer.addEffect(new EntitySplashFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("largesmoke"))
-        {
-            mc.effectRenderer.addEffect(new EntitySmokeFX(worldObj, x, y, z, motionX, motionY, motionZ, 2.5F));
-        }
-        else if(particleId.equals("reddust"))
-        {
-            mc.effectRenderer.addEffect(new EntityReddustFX(worldObj, x, y, z, (float)motionX, (float)motionY, (float)motionZ));
-        }
-        else if(particleId.equals("item"))
-        {
-            mc.effectRenderer.addEffect(new EntityItemFX(worldObj, x, y, z, Item.itemsList[(int) (motionX + 0.001d)]));
-        }
-        else if(particleId.equals("block"))
-        {
-            mc.effectRenderer.addEffect(new EntityDiggingFX(worldObj, x, y, z, 0, 0, 0, Block.blocksList[(int) (motionX + 0.001d)], 0,(int) (motionY + 0.001d) ));
-        }
-        else if(particleId.equals("snowshovel"))
-        {
-            mc.effectRenderer.addEffect(new EntitySnowShovelFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("heart"))
-        {
-            mc.effectRenderer.addEffect(new EntityHeartFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("slimechunk"))
-        {
-        	if(mc.gameSettings.slimeParticles.value) {
-        		mc.effectRenderer.addEffect(new EntitySlimeChunkFX(worldObj, x, y, z, Item.slimeball));
-        	}
-        }
-        else if(particleId.equals("fireflyGreen"))
-        {
-            mc.effectRenderer.addEffect(new EntityFireflyFX(worldObj, x, y, z, motionX, motionY, motionZ, 2.5F, EntityFireflyCluster.FireflyColor.GREEN.getId()));
-        }
-        else if(particleId.equals("fireflyBlue"))
-        {
-            mc.effectRenderer.addEffect(new EntityFireflyFX(worldObj, x, y, z, motionX, motionY, motionZ, 2.5F, EntityFireflyCluster.FireflyColor.BLUE.getId()));
-        }
-        else if(particleId.equals("fireflyOrange"))
-        {
-            mc.effectRenderer.addEffect(new EntityFireflyFX(worldObj, x, y, z, motionX, motionY, motionZ, 2.5F, EntityFireflyCluster.FireflyColor.ORANGE.getId()));
-        }
-        else if(particleId.equals("fireflyRed"))
-        {
-            mc.effectRenderer.addEffect(new EntityFireflyFX(worldObj, x, y, z, motionX, motionY, motionZ, 2.5F, EntityFireflyCluster.FireflyColor.RED.getId()));
-        }
-        else if(particleId.equals("arrowtrail"))
-        {
-        	mc.effectRenderer.addEffect(new EntityArrowGoldenFX(worldObj, x, y, z, motionX, motionY, motionZ));
-        }
-        else if(particleId.equals("fallingleaf"))
-        {
-        	int id = worldObj.getBlockId((int)x, (int)y, (int)z);
-        	if (id != 0)
-        	{
-        		mc.effectRenderer.addEffect(new EntityLeafFX(worldObj, x, y, z, motionX, motionY, motionZ).func_4041_a((int)x, (int)y, (int)z));
-        	}
-        }
-        else if (particleId.equals("boatbreak"))
-        {
-            mc.effectRenderer.addEffect(new EntityDiggingFX(worldObj, x, y, z, motionX, motionY, motionZ, Block.planksOak, 0,0));
+        EntityFX fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ);
+        if (fx != null){
+            mc.effectRenderer.addEffect(fx);
         }
     }
     
@@ -1855,10 +1728,11 @@ public class RenderGlobal
         case 1005: // Jukebox play/stop record
             if(Item.itemsList[data] instanceof ItemRecord)
             {
-                worldObj.playRecord(((ItemRecord)Item.itemsList[data]).recordName, x, y, z);
+                ItemRecord record = ((ItemRecord)Item.itemsList[data]);
+                worldObj.playRecord(record.recordName, record.recordAuthor, x, y, z);
             } else
             {
-                worldObj.playRecord(null, x, y, z);
+                worldObj.playRecord(null, null, x, y, z);
             }
             break;
         case 1006: // Piston extend
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index dad6f9dc5..c248b49e6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -298,6 +298,7 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorPlanksOak).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/trapdoor_planks_oak_side"));
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorIron).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/trapdoor_iron_side"));
         addDispatch(new BlockModelTrapDoor<>(Block.trapdoorGlass).withTextures("minecraft:block/glass", "minecraft:block/trapdoor_glass_side"));
+        addDispatch(new BlockModelTrapDoor<>(Block.trapdoorGlassTinted).withTextures("minecraft:block/glass_tinted", "minecraft:block/trapdoor_glass_tinted_side"));
         addDispatch(new BlockModelTrapDoorPainted<>(Block.trapdoorPlanksOakPainted));
 
         addDispatch(new BlockModelStandard<>(Block.tnt).withTextures("minecraft:block/tnt_top", "minecraft:block/tnt_bottom", "minecraft:block/tnt_side"));
@@ -310,6 +311,8 @@ public class BlockModelDispatcher
         addDispatch(new BlockModelDoorPainted<>(Block.doorPlanksOakPaintedTop, true).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_top"));
         addDispatch(new BlockModelDoorGlass<>(Block.doorGlassBottom).withTextures("minecraft:block/glass", "minecraft:block/door_glass_bottom"));
         addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTop).withTextures("minecraft:block/glass", "minecraft:block/door_glass_top"));
+        addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTintedBottom).withTextures("minecraft:block/glass_tinted", "minecraft:block/door_glass_tinted_bottom"));
+        addDispatch(new BlockModelDoorGlass<>(Block.doorGlassTintedTop).withTextures("minecraft:block/glass_tinted", "minecraft:block/door_glass_tinted_top"));
 
         addDispatch(new BlockModelTransparent<>(Block.mesh, true).withTextures("minecraft:block/mesh"));
         addDispatch(new BlockModelTransparent<>(Block.meshGold, true).withTextures("minecraft:block/mesh_gold"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index 4d1034b65..4ffaf1152 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.Vec3d;
 
@@ -16,8 +17,8 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        int i1 = l & 7;
-        boolean flag = (l & 8) > 0;
+        int i1 = l & 15;
+        boolean flag = (l & 16) > 0;
         boolean flag1 = renderBlocks.overrideBlockTexture != null;
         if(!flag1)
         {
@@ -26,27 +27,28 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
         float f = 0.25F;
         float f1 = 0.1875F;
         float f2 = 0.1875F;
-        if(i1 == 5)
+        if(i1 == 7)
+        {
+            block.setBlockBounds(0.5F - f1, 1f - f2, 0.5F - f, 0.5F + f1, 1f, 0.5F + f);
+        } else if(i1 == 8)
+        {
+            block.setBlockBounds(0.5F - f, 1f - f2, 0.5F - f1, 0.5F + f, 1f, 0.5F + f1);
+        } else if(i1 == 5)
         {
             block.setBlockBounds(0.5F - f1, 0.0F, 0.5F - f, 0.5F + f1, f2, 0.5F + f);
-        } else
-        if(i1 == 6)
+        } else if(i1 == 6)
         {
             block.setBlockBounds(0.5F - f, 0.0F, 0.5F - f1, 0.5F + f, f2, 0.5F + f1);
-        } else
-        if(i1 == 4)
+        } else if(i1 == 4)
         {
             block.setBlockBounds(0.5F - f1, 0.5F - f, 1.0F - f2, 0.5F + f1, 0.5F + f, 1.0F);
-        } else
-        if(i1 == 3)
+        } else if(i1 == 3)
         {
             block.setBlockBounds(0.5F - f1, 0.5F - f, 0.0F, 0.5F + f1, 0.5F + f, f2);
-        } else
-        if(i1 == 2)
+        } else if(i1 == 2)
         {
             block.setBlockBounds(1.0F - f2, 0.5F - f, 0.5F - f1, 1.0F, 0.5F + f, 0.5F + f1);
-        } else
-        if(i1 == 1)
+        } else if(i1 == 1)
         {
             block.setBlockBounds(0.0F, 0.5F - f, 0.5F - f1, f2, 0.5F + f, 0.5F + f1);
         }
@@ -99,38 +101,43 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
                 avec3d[i2].zCoord += 0.0625D;
                 avec3d[i2].rotateAroundX(-0.6981317F);
             }
-            if(i1 == 6)
+            if(i1 == 6 || i1 == 8)
             {
-                avec3d[i2].rotateAroundY(1.570796F);
+                avec3d[i2].rotateAroundY(MathHelper.PI/2f);
             }
             if(i1 < 5)
             {
                 avec3d[i2].yCoord -= 0.375D;
-                avec3d[i2].rotateAroundX(1.570796F);
+                avec3d[i2].rotateAroundX(MathHelper.PI/2f);
                 if(i1 == 4)
                 {
                     avec3d[i2].rotateAroundY(0.0F);
                 }
                 if(i1 == 3)
                 {
-                    avec3d[i2].rotateAroundY(3.141593F);
+                    avec3d[i2].rotateAroundY(MathHelper.PI);
                 }
                 if(i1 == 2)
                 {
-                    avec3d[i2].rotateAroundY(1.570796F);
+                    avec3d[i2].rotateAroundY(MathHelper.PI/2f);
                 }
                 if(i1 == 1)
                 {
-                    avec3d[i2].rotateAroundY(-1.570796F);
+                    avec3d[i2].rotateAroundY(-MathHelper.PI/2f);
                 }
                 avec3d[i2].xCoord += (double)x + 0.5D;
                 avec3d[i2].yCoord += (float)y + 0.5F;
                 avec3d[i2].zCoord += (double)z + 0.5D;
-            } else
+            } else if (i1 == 5 || i1 == 6)
             {
                 avec3d[i2].xCoord += (double)x + 0.5D;
                 avec3d[i2].yCoord += (float)y + 0.125F;
                 avec3d[i2].zCoord += (double)z + 0.5D;
+            } else {
+                avec3d[i2].rotateAroundX(MathHelper.PI);
+                avec3d[i2].xCoord += (double)x + 0.5D;
+                avec3d[i2].yCoord += (float)(y + 1) - 0.125F;
+                avec3d[i2].zCoord += (double)z + 0.5D;
             }
         }
 
diff --git a/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java b/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java
index f66040ded..05aee87a8 100644
--- a/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java
+++ b/src/main/java/net/minecraft/client/render/canvas/CanvasMojangLogo.java
@@ -17,7 +17,7 @@ public class CanvasMojangLogo extends Canvas
     {
         try
         {
-            logo = ImageIO.read((PanelCrashReport.class).getResource("/gui/logo.png"));
+            logo = ImageIO.read((PanelCrashReport.class).getResource("/assets/minecraft/textures/gui/logo.png"));
         }
         catch(IOException ioexception) { }
         byte byte0 = 100;
diff --git a/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
index 6cf990707..6c6bd7ace 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
@@ -12,7 +12,7 @@ public class ArrowRenderer extends EntityRenderer<EntityArrow>
     public void renderArrow(EntityArrow arrow, double x, double y, double z,
                             float yaw, float partialTick)
     {
-        loadTexture("/item/arrows.png");
+        loadTexture("/assets/minecraft/textures/entity/arrows.png");
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
         GL11.glRotatef((arrow.yRotO + (arrow.yRot - arrow.yRotO) * partialTick) - 90F, 0.0F, 1.0F, 0.0F);
diff --git a/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java b/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java
index 8ab12c68d..f50f2e07b 100644
--- a/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/CannonballRenderer.java
@@ -24,7 +24,7 @@ public class CannonballRenderer extends EntityRenderer<EntityCannonball>
         GL11.glPushMatrix();
         GL11.glTranslatef((float)d, (float)d1, (float)d2);
         GL11.glRotatef(180F - f, 0.0F, 1.0F, 0.0F);
-        loadTexture("/item/cannonball.png");
+        loadTexture("/assets/minecraft/textures/entity/cannonball.png");
         GL11.glScalef(-1F, -1F, 1.0F);
         modelCannonball.render(0.0F, 0.0F, -0.1F, 0.0F, 0.0F, 0.03125F);
         GL11.glPopMatrix();
diff --git a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
index d922e676c..127aa1642 100644
--- a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
@@ -1,8 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import java.util.Random;
-
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessalator.Tessellator;
@@ -11,10 +8,13 @@ import net.minecraft.core.Global;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
+import java.util.Random;
+
 public class PaintingRenderer extends EntityRenderer<EntityPainting>
 {
     private static final IconCoordinate paintingBack = TextureRegistry.getTexture("minecraft:art/backing");
@@ -146,7 +146,8 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(770, 771);
             GL11.glColor4f(1f, 1f, 1f, 1f);
-            loadTexture(EntityPainting.getBorder(borderStack));
+            NamespaceID id = EntityPainting.getBorder(borderStack);
+            loadTexture(String.format("/assets/%s/textures/art/borders/%s.png", id.namespace, id.value));
             renderBorder(entity, entity.art.sizeX, entity.art.sizeY);
             GL11.glDisable(GL11.GL_BLEND);
         }
diff --git a/src/main/java/net/minecraft/client/render/entity/PigRenderer.java b/src/main/java/net/minecraft/client/render/entity/PigRenderer.java
index fc9df826e..1006165b7 100644
--- a/src/main/java/net/minecraft/client/render/entity/PigRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PigRenderer.java
@@ -18,7 +18,7 @@ public class PigRenderer extends LivingRenderer<EntityPig>
 
     protected boolean renderSaddledPig(EntityPig entity, int i, float f)
     {
-        loadTexture("/mob/saddle.png");
+        loadTexture("/assets/minecraft/textures/entity/saddle.png");
         return i == 0 && entity != null && entity.getSaddled();
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 7d9717daf..231e97e1e 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -50,7 +50,7 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
             Item item = itemstack.getItem();
             if(item instanceof ItemQuiver)
             {
-                loadTexture("/armor/quiver.png");
+                loadTexture("/assets/minecraft/textures/armor/quiver.png");
                 ModelBiped modelbiped = modelArmorChestplate;
                 modelbiped.bipedBody.showModel = renderPass == 1 || renderPass == 2;
                 setRenderPassModel(modelbiped);
@@ -58,7 +58,7 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
             }
             if(item instanceof ItemQuiverEndless)
             {
-                loadTexture("/armor/quiver_golden.png");
+                loadTexture("/assets/minecraft/textures/armor/quiver_golden.png");
                 ModelBiped modelbiped = modelArmorChestplate;
                 modelbiped.bipedBody.showModel = renderPass == 1 || renderPass == 2;
                 setRenderPassModel(modelbiped);
@@ -66,7 +66,7 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
             }
             if(item == Item.armorBootsIceskates)
             {
-                loadTexture("/armor/skates.png");
+                loadTexture("/assets/minecraft/textures/armor/skates.png");
                 ModelBiped modelbiped = modelArmorChestplate;
                 modelbiped.bipedRightLeg.showModel = renderPass == 2 || renderPass == 3;
                 modelbiped.bipedLeftLeg.showModel = renderPass == 2 || renderPass == 3;
@@ -76,7 +76,7 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
             if(item instanceof ItemArmor)
             {
                 ItemArmor itemarmor = (ItemArmor)item;
-                loadTexture("/armor/"+itemarmor.material.name+"_"+(renderPass != 2 ? 1 : 2)+".png");
+                loadTexture(String.format("/assets/%s/textures/armor/%s_%d.png", itemarmor.material.identifier.namespace, itemarmor.material.identifier.value, (renderPass != 2 ? 1 : 2)));
                 ModelBiped modelbiped = renderPass != 2 ? modelArmorChestplate : modelArmor;
                 modelbiped.bipedHead.showModel = renderPass == 0;
                 modelbiped.bipedHeadOverlay.showModel = renderPass == 0;
diff --git a/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java b/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
index 7d5359f1f..495bcad9f 100644
--- a/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SheepRenderer.java
@@ -16,14 +16,14 @@ public class SheepRenderer extends LivingRenderer<EntitySheep>
     {
         super(body, f);
         setRenderPassModel(wool);
-        setOverlayModel(overlay, "/mob/sheep_overlay.png");
+        setOverlayModel(overlay, "/assets/minecraft/textures/entity/sheep_overlay.png");
     }
 
     protected boolean setWoolColorAndRender(EntitySheep entitysheep, int i, float f)
     {
         if(i == 0 && !entitysheep.getSheared())
         {
-            loadTexture("/mob/sheep_fur.png");
+            loadTexture("/assets/minecraft/textures/entity/sheep_fur.png");
             float brightness = 1.0f;
             if(LightmapHelper.isLightmapEnabled() || Global.accessor.isFullbrightEnabled()) {
             	
diff --git a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
index c764fa89b..67517ddd6 100644
--- a/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/SpiderRenderer.java
@@ -14,8 +14,8 @@ public class SpiderRenderer extends LivingRenderer<EntitySpider>
 
     public SpiderRenderer()
     {
-        super(new ModelSpider(), 1.0F);
-        setRenderPassModel(new ModelSpider());
+        super(new ModelSpider(0), 1.0F);
+        setRenderPassModel(new ModelSpider(0.01f));
     }
 
     protected float setSpiderDeathMaxRotation(EntitySpider spider)
@@ -23,11 +23,12 @@ public class SpiderRenderer extends LivingRenderer<EntitySpider>
         return 180F;
     }
 
-    protected boolean setSpiderEyeBrightness(EntitySpider spider, int i, float f)
+    protected boolean setSpiderEyeBrightness(EntitySpider spider, int renderPass, float partialTick)
     {
-        if(i == 0)
+        if(renderPass == 0)
         {
-            loadTexture("/mob/spider_eyes.png");
+            boolean useVariants = Minecraft.getMinecraft(this).gameSettings.mobVariants.value;
+            loadTexture("/assets/minecraft/textures/entity/spider/eyes/" + (useVariants ? spider.getSkinVariant() : 0) + ".png");
             float brightness = spider.getBrightness(1.0f);
             if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
             float f1 = (1.0F - brightness) * 0.5F;
diff --git a/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java b/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java
index dc79d6443..fae8fea94 100644
--- a/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/WolfRenderer.java
@@ -28,7 +28,7 @@ public class WolfRenderer extends LivingRenderer<EntityWolf>
         if (material == null) {
             return false;
         }
-        loadTexture("/armor/wolf/" + material.name.toLowerCase() + ".png");
+        loadTexture(String.format("/assets/%s/textures/armor/wolf/%s.png", material.identifier.namespace, material.identifier.value));
         setRenderPassModel(modelArmor);
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 3bc301f0e..2c35b8392 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -113,6 +113,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Item.sign, "minecraft"));
         addDispatch(new ItemModelStandard(Item.doorOak, "minecraft"));
         addDispatch(new ItemModelStandard(Item.doorGlass, "minecraft"));
+        addDispatch(new ItemModelStandard(Item.doorGlassTinted, "minecraft"));
         addDispatch(new ItemModelDoorPainted(Item.doorOakPainted));
         addDispatch(new ItemModelStandard(Item.bucket, "minecraft"));
         addDispatch(new ItemModelStandard(Item.bucketWater, "minecraft"));
